
#Each entry will need
# df : data drame of Inputs (in order), Outputs (in order) and FullEvalTime
# Name (also used as the ID)
# inputNum: number of inputs
# outputNum: number of outputs
# Output_max: vector (use c( ) ) of T/F (maximize this output?)
# ParetoFront (generate this from the df)
# InputLimits (a list of vectors of the min and max one for each input --
#             Inputs MUST be integers and exactly 1 apart)
# Notes : Note the scaling of inputs as necessary eg: "Input1/100 is price in pounds"


#basic cleaning
rm(list=ls()) #variables

load("fileOfMSOprototypeFunctions")
AnswerBook_fileName="AnswerBook";


reqSimulation="nil";
generateParetoFronts=T;
RusesPort<-2113;

needToSave<-F;
AnswerKeyToAdd=list();
AnswerKeyToAdd$Name=reqSimulation;
if (reqSimulation=="StudentServices"){
  inputNum=2;
  outputNum=3;
  AnswerKeyToAdd$Output_max <- c(F,F);
  
  AnswerKeyToAdd$inputNum <- inputNum;
  AnswerKeyToAdd$outputNum <- outputNum;
  #this is the one for Student Services
  
  df_AnswerKey <- expand.grid(5:14,5:14,5:14,KEEP.OUT.ATTRS= FALSE)
  
  #TODO: make this a function that takes a matrix of inputs and a number (eg:2) of outputs
  
  #inputs
  names(df_AnswerKey)[1]="Input1"; #Generalist
  names(df_AnswerKey)[2]="Input2"; #Specialist1
  names(df_AnswerKey)[3]="Input3"; #Specialist2
  
  #outputs
  df_AnswerKey[,c("Output1","Output2")]=NA;
  
  df_AnswerKey[,"FullEvalTime"]=NA;
  
  #we will now fill the parts correspondingly
  
  for (i in 1:nrow(df_AnswerKey)){
    qualNums=reqEvaluation(i,df_AnswerKey);
    df_AnswerKey[i,(inputNum+1):(inputNum+outputNum+1)]=qualNums;
  }
  #save this answer key
  needToSave<-T;
}
  
if (reqSimulation=="Telecom"){
  AnswerKeyToAdd$Name="Telecom";
  inputNum=2;
  outputNum=3;
  AnswerKeyToAdd$Output_max <- c(T,T,F);
  
  AnswerKeyToAdd$inputNum <- inputNum;
  AnswerKeyToAdd$outputNum <- outputNum;
  #this is the one for Student Services
  df_AnswerKey <- expand.grid(0:50,0:20,KEEP.OUT.ATTRS= FALSE)
  
  #TODO: make this a function that takes a matrix of inputs and a number (eg:2) of outputs
  
  #inputs
  names(df_AnswerKey)[1]="Input1"; #Price
  names(df_AnswerKey)[2]="Input2"; #Aggressiveness

  
  #outputs
  df_AnswerKey[,c("Output1","Output2","Output3")]=NA;
  
  df_AnswerKey[,"FullEvalTime"]=NA;
  
  #we will now fill the parts correspondingly
  
  for (i in 1:nrow(df_AnswerKey)){
    qualNums=reqEvaluation(i,df_AnswerKey);
    df_AnswerKey[i,(inputNum+1):(inputNum+outputNum+1)]=qualNums;
    string=paste(c(i," done of ",nrow(df_AnswerKey)),collapse="");
    print(string);
  }

  #save this answer key
  needToSave<-T;
}

#saving into the Book
load(AnswerBook_fileName);


if (needToSave){
  AnswerKeyToAdd$df=df_AnswerKey;
  AnswerBook[[(length(AnswerBook)+1)]]=AnswerKeyToAdd;
  needToSave<-F;
}


if (generateParetoFronts){
  for (countP in 1:length(AnswerBook))
  {
    if (is.null(AnswerBook[[countP]]$paretoFront)){
          #generate this
      inputNum=AnswerBook[[countP]]$inputNum;
      outputNum=AnswerBook[[countP]]$outputNum;
      output_max <- AnswerBook[[countP]]$Output_max;
      
      pareto <- findParetoFront(AnswerBook[[countP]]$df);
      AnswerBook[[countP]]$paretoFront <- pareto;
      rm(pareto);
    }
    
  }

}





#review AnswerBook before saving
##  save(AnswerBook,file=AnswerBook_fileName)



