#basic cleaning
rm(list=ls()) #variables






#this is for generating a RECORD for experiments
#record means "dataframes + other things in a list !
record_experiments=list();
record_experiments$paretoFronts=list();

#produce the dataframe we will load in
#the first row will be a placeholder
df=data.frame();
df[1,"ExternalProgram"]="AnyLogic"; #R ....
df[1,"UnderlyingModel"]="StudentServices"; #OR ....
df[1,"SurrogateType"]="GaussianRegression" ; #OR....
df[1,"Optimizer"]="Basic"; #OR....
df[1,"InitialSample"]=20; #OR other integers, obviously
df[1,"TimeLimit"]=15;
df[1,"Replication"]=1;
df[1,"ExpID"]=1;
df[1,"FullEvaluationRuns"]=0;
df[1,"FullEvaluationTime"]=0;
df[1,"SurrogateRuns"]=0;
df[1,"SurrogateOptimizerTime"]=0;

df <- df[-1,]#remove the placeholder first first row used to set up

#the function to add an experiment
addExperiment= function(df,numTimes,ExternalProgram,UnderlyingModel,SurrogateType,Optimizer,
                        InitialSample,TimeLimit,ExpID){
  #we have 6 inputs currently, exp id done separately
  nInputs=6;
  for (i in 1:numTimes){
    df[nrow(df)+1,1:(nInputs+1)]=c(ExternalProgram,UnderlyingModel,SurrogateType,Optimizer,
                                InitialSample,TimeLimit,i);
  }
  return(df);
}


#All other data is available from the appropriate AnswerKey

#==========================================================
##user sets up experiments BELOW this =================================

experimentRecord_name="Exp_CNTNV_08";
usePresetExperiments <- T;
preset_toUse <- "CNTNV";

#Custom Definition
if (!usePresetExperiments){
  ExternalProgram="SimOpt";
  UnderlyingModel="DualSourcing";
  InitialSamples <- c(84); #1681 input combos
  TimeLimits <- 60*(4:7);
  Replications <- 50;
}


if (usePresetExperiments & preset_toUse=="DualSourcing"){
  ExternalProgram="SimOpt";
  UnderlyingModel="DualSourcing";
  InitialSamples <- c(100); #Input space about 1650
  TimeLimits <- 60*(4:7);
  Replications <- 50;
}


if (usePresetExperiments & preset_toUse=="CNTNV"){
  ExternalProgram="SimOpt";
  UnderlyingModel="CNTNV";
  InitialSamples <- c(32); #input space has 650, this is around 5%
  TimeLimits <- 50*(2:5);
  Replications <- 50;
}

if (usePresetExperiments & preset_toUse=="Telecom"){
  ExternalProgram="Anylogic";
  UnderlyingModel="Telecom";
  InitialSamples <- c(54); #input space has 1071, this is around 5%
  TimeLimits <- 25*(1:4);
  Replications <- 50;
}

if (usePresetExperiments & preset_toUse=="StudentServices"){
  ExternalProgram="Anylogic";
  UnderlyingModel="StudentServices";
  InitialSamples <- c(50); #input space has 1000, this is around 5%
  TimeLimits <- 25*(2:5);
  Replications <- 50;
}






for (SurrogateType in c("GaussianRegression","neuralnet")){
  for (Optimizer in c("GeneticAlgorithm1","Basic")){
    for (InitialSample in InitialSamples){
      for (TimeLimit in TimeLimits){
        df <- addExperiment(df, Replications,
                            ExternalProgram=ExternalProgram,
                            UnderlyingModel=UnderlyingModel,
                            SurrogateType=SurrogateType,
                            Optimizer=Optimizer,
                            InitialSample=InitialSample,
                            TimeLimit=TimeLimit);
      }
    }
  }
}
df$ExpID <- 1:nrow(df);
df$InitialSample <- as.numeric(df$InitialSample);
df$TimeLimit <- as.numeric(df$TimeLimit);
#==========================================================
#creates the record
record_experiments$df <- df;

rm(ExternalProgram,UnderlyingModel,SurrogateType,Optimizer,InitialSample,TimeLimit);
save(record_experiments,file=experimentRecord_name);



