#basic cleaning
rm(list=ls()) #variables
if (!is.null(dev.list()["RStudioGD"])){
dev.off(dev.list()["RStudioGD"])} #previous plots


#all settings etc
experimentInput_name="Exp_CNTNV_08"; #read from here
load("KeyRing");

RusesPort<-2113;
showPlots <- F; #depreciated, might not affect anything now, DO NOT USE

#======================================================
#all requirements

#potentially some of these will not be needed in final version
#if they were "swapped out" for alternatives

require('lhs')||install.packages('lhs')
require('GPFDA')||install.packages("GPFDA")
require(MASS)||install.packages(MASS)
require(interp)||install.packages(interp)
require(fields)||install.packages(fields)
require('kriging')||install.packages("kriging")
require(tidyverse)||install.packages(tidyverse)
require(neuralnet)||install.packages(neuralnet)

#======================================================
#Library of functions
#These are loaded but are called later on ONLY
load("fileOfMSOprototypeFunctions")

OutputMessages <- list()
OutputMessages$Explain <- "This keeps messages for the user"






#======================================================
#======================================================
#======================================================
#main code that runs things





#everything else follows===================

#load our experiment list
load(experimentInput_name);
record_experiments$UnitsUsed="Times are in seconds";
currentSimulation="placeholder";

for (count_experiment in 1:nrow(record_experiments$df)){
  UnderlyingModel=record_experiments$df$UnderlyingModel[count_experiment];
  
  #pull out the right answer key
  foundAnswerKey=(currentSimulation==UnderlyingModel);
  if (!foundAnswerKey){
   #we need to load a new one
    for (i in 1:length(KeyRing)){
      if (KeyRing[[i]]$Name==UnderlyingModel){
       foundAnswerKey=T;
       load(KeyRing[[i]]$FileLocation);
       df_AnswerKey <- AnswerKey$df;
       currentSimulation <- UnderlyingModel;
       inputNum <- AnswerKey$inputNum;
       outputNum <- AnswerKey$outputNum;
       output_max <- AnswerKey$Output_max;
       Limits <- AnswerKey$InputLimits; #Input limits
      }
    }
  }
  #hopefully we found it...
  if(!foundAnswerKey){
    string=paste("AnswerKey not found for: ",UnderlyingModel,collapse="");
    OutputMessages[[length(OutputMessages)+1]] <- string;
    print(string);
  }
  


  
  
  
  if(!is.na(record_experiments$df$FullEvaluationRuns[count_experiment]))
  {
    print(paste("Already Done: Experiment #",count_experiment,"of",nrow(record_experiments$df),collapse="")); 
   next 
  }
  
  #the surrogate etc is all called within the handler
  record_experiments = optimizationHandler(count_experiment,record_experiments);
  
  print(paste("Done: Experiment #",count_experiment,"of",nrow(record_experiments$df),collapse="")); 
  #View(record_experiments$df)
  
  #saving this finished experiment before going to the next
  save(record_experiments,file=experimentInput_name);
  
}



#see just the results right now
View(record_experiments$df);


